Core - Bug # 57856

Status: Under Review Priority: Should have
Author: Stefan Neufeind Category: Extbase
Created: 2014-04-12 Assigned To:

Updated: 2015-07-18 Due date:

TYPO3 Version: 7

PHP Version:

Complexity:

Is Regression: No

Sprint Focus: On Location Sprint

Subject: @inject does not work relative to current namespace

Description

So far you always need to give the full classpath including full namespace for an @inject. That's the way it is currently used. It would
be great if @inject would also allow to use the current namespace.

Or maybe even make use of "use"-statements?

Related issues:

related to TYPOS3.Flow - Bug # 46008: Reflection should resolve relative names... Resolved 2013-03-04
related to Core - Task # 57878: Cleanup Extbase Reflection classes Resolved 2014-04-13
History

#1 - 2014-04-13 02:19 - Markus Klein

Flow has a solution for this: https://review.typo3.org/20158

#2 - 2014-04-13 02:31 - Markus Klein

They even support the use statement. But this comes with high costs. You need to parse the file in order to retrieve the use statements. Flow uses the

doctrine phpparser for this.

For the purpose of extbase | suggest to only resolve the current namespace, which is easy.

#3 - 2014-04-13 03:02 - Stefan Neufeind

Can't we take that "cost"? Reflection is cached anyway.

We don't have Doctrine yet. So | think for "use" only we can come up with a minimal parser - maybe even with some hardcoded limitations for now. We
might get Doctrine anyway afaik, sooner or later.

Thanks for the link to that patch. Looks doable imho ...

#4 - 2014-04-13 03:07 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/29436

2015-08-04 1/4



https://review.typo3.org/20158
https://review.typo3.org/29436

#5 - 2014-04-13 15:53 - Markus Klein

| agree now that we should add the use stmt support as well.

#6 - 2014-04-13 17:16 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/29436

#7 - 2014-06-17 20:21 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/29436

#8 - 2014-06-17 20:21 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/29436

#9 - 2015-01-08 21:38 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/29436

#10 - 2015-01-08 22:34 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/29436

#11 - 2015-01-09 11:35 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/29436

#12 - 2015-04-30 12:13 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0org/38359

#13 - 2015-04-30 14:27 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/38359
#14 - 2015-04-30 15:27 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38359

#15 - 2015-04-30 15:37 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/38359

#16 - 2015-04-30 16:42 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/38359

#17 - 2015-04-30 20:56 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38359

#18 - 2015-05-01 11:47 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/38359

#19 - 2015-05-01 13:23 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/38359

#20 - 2015-05-01 13:24 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38359

#21 - 2015-05-01 18:00 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/38359

#22 - 2015-05-01 18:02 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/38359
#23 - 2015-05-01 19:46 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38359

#24 - 2015-07-17 21:15 - Sebastian Michaelsen
- Target version set to 7.4 (Backend)
- Sprint Focus set to On Location Sprint

#25 - 2015-07-17 21:18 - Sebastian Michaelsen
- TYPOS3 Version changed from 6.2 to 7

#26 - 2015-07-18 01:22 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/38359

2015-08-04 4/4


http://review.typo3.org/38359
http://review.typo3.org/38359

